# coding: utf-8

"""
    UiPath.WebApi 18.0

    Orchestrator API  # noqa: E501

    OpenAPI spec version: 18.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from uipath_orchestrator_rest.configuration import Configuration


class EnvironmentDto(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'str',
        'description': 'str',
        'robots': 'list[SimpleRobotDto]',
        'type': 'str',
        'id': 'int'
    }

    attribute_map = {
        'name': 'Name',
        'description': 'Description',
        'robots': 'Robots',
        'type': 'Type',
        'id': 'Id'
    }

    def __init__(self, name=None, description=None, robots=None, type=None, id=None, _configuration=None):  # noqa: E501
        """EnvironmentDto - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._name = None
        self._description = None
        self._robots = None
        self._type = None
        self._id = None
        self.discriminator = None

        self.name = name
        if description is not None:
            self.description = description
        if robots is not None:
            self.robots = robots
        if type is not None:
            self.type = type
        if id is not None:
            self.id = id

    @property
    def name(self):
        """Gets the name of this EnvironmentDto.  # noqa: E501

        A custom name for the environment.  # noqa: E501

        :return: The name of this EnvironmentDto.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this EnvironmentDto.

        A custom name for the environment.  # noqa: E501

        :param name: The name of this EnvironmentDto.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501
        if (self._configuration.client_side_validation and
                name is not None and len(name) > 100):
            raise ValueError("Invalid value for `name`, length must be less than or equal to `100`")  # noqa: E501
        if (self._configuration.client_side_validation and
                name is not None and len(name) < 0):
            raise ValueError("Invalid value for `name`, length must be greater than or equal to `0`")  # noqa: E501

        self._name = name

    @property
    def description(self):
        """Gets the description of this EnvironmentDto.  # noqa: E501

        Used to add additional information about an environment in order to better identify it.  # noqa: E501

        :return: The description of this EnvironmentDto.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this EnvironmentDto.

        Used to add additional information about an environment in order to better identify it.  # noqa: E501

        :param description: The description of this EnvironmentDto.  # noqa: E501
        :type: str
        """
        if (self._configuration.client_side_validation and
                description is not None and len(description) > 500):
            raise ValueError("Invalid value for `description`, length must be less than or equal to `500`")  # noqa: E501
        if (self._configuration.client_side_validation and
                description is not None and len(description) < 0):
            raise ValueError("Invalid value for `description`, length must be greater than or equal to `0`")  # noqa: E501

        self._description = description

    @property
    def robots(self):
        """Gets the robots of this EnvironmentDto.  # noqa: E501

        The collection of robots associated with the current environment.  # noqa: E501

        :return: The robots of this EnvironmentDto.  # noqa: E501
        :rtype: list[SimpleRobotDto]
        """
        return self._robots

    @robots.setter
    def robots(self, robots):
        """Sets the robots of this EnvironmentDto.

        The collection of robots associated with the current environment.  # noqa: E501

        :param robots: The robots of this EnvironmentDto.  # noqa: E501
        :type: list[SimpleRobotDto]
        """

        self._robots = robots

    @property
    def type(self):
        """Gets the type of this EnvironmentDto.  # noqa: E501

        DEPRECATED. The environment type specifies how it should be used.  This property is deprecated and should no longer be used.  # noqa: E501

        :return: The type of this EnvironmentDto.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this EnvironmentDto.

        DEPRECATED. The environment type specifies how it should be used.  This property is deprecated and should no longer be used.  # noqa: E501

        :param type: The type of this EnvironmentDto.  # noqa: E501
        :type: str
        """
        allowed_values = ["Dev", "Test", "Prod"]  # noqa: E501
        if (self._configuration.client_side_validation and
                type not in allowed_values):
            raise ValueError(
                "Invalid value for `type` ({0}), must be one of {1}"  # noqa: E501
                .format(type, allowed_values)
            )

        self._type = type

    @property
    def id(self):
        """Gets the id of this EnvironmentDto.  # noqa: E501


        :return: The id of this EnvironmentDto.  # noqa: E501
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this EnvironmentDto.


        :param id: The id of this EnvironmentDto.  # noqa: E501
        :type: int
        """

        self._id = id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(EnvironmentDto, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, EnvironmentDto):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, EnvironmentDto):
            return True

        return self.to_dict() != other.to_dict()
