# coding: utf-8

"""
    UiPath.WebApi 18.0

    Orchestrator API  # noqa: E501

    OpenAPI spec version: 18.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from uipath_orchestrator_rest.configuration import Configuration


class SessionMaintenanceModeParameters(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'session_id': 'int',
        'maintenance_mode': 'str',
        'stop_jobs_strategy': 'str'
    }

    attribute_map = {
        'session_id': 'sessionId',
        'maintenance_mode': 'maintenanceMode',
        'stop_jobs_strategy': 'stopJobsStrategy'
    }

    def __init__(self, session_id=None, maintenance_mode=None, stop_jobs_strategy=None, _configuration=None):  # noqa: E501
        """SessionMaintenanceModeParameters - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._session_id = None
        self._maintenance_mode = None
        self._stop_jobs_strategy = None
        self.discriminator = None

        if session_id is not None:
            self.session_id = session_id
        if maintenance_mode is not None:
            self.maintenance_mode = maintenance_mode
        if stop_jobs_strategy is not None:
            self.stop_jobs_strategy = stop_jobs_strategy

    @property
    def session_id(self):
        """Gets the session_id of this SessionMaintenanceModeParameters.  # noqa: E501


        :return: The session_id of this SessionMaintenanceModeParameters.  # noqa: E501
        :rtype: int
        """
        return self._session_id

    @session_id.setter
    def session_id(self, session_id):
        """Sets the session_id of this SessionMaintenanceModeParameters.


        :param session_id: The session_id of this SessionMaintenanceModeParameters.  # noqa: E501
        :type: int
        """

        self._session_id = session_id

    @property
    def maintenance_mode(self):
        """Gets the maintenance_mode of this SessionMaintenanceModeParameters.  # noqa: E501


        :return: The maintenance_mode of this SessionMaintenanceModeParameters.  # noqa: E501
        :rtype: str
        """
        return self._maintenance_mode

    @maintenance_mode.setter
    def maintenance_mode(self, maintenance_mode):
        """Sets the maintenance_mode of this SessionMaintenanceModeParameters.


        :param maintenance_mode: The maintenance_mode of this SessionMaintenanceModeParameters.  # noqa: E501
        :type: str
        """
        allowed_values = ["Default", "Enabled"]  # noqa: E501
        if (self._configuration.client_side_validation and
                maintenance_mode not in allowed_values):
            raise ValueError(
                "Invalid value for `maintenance_mode` ({0}), must be one of {1}"  # noqa: E501
                .format(maintenance_mode, allowed_values)
            )

        self._maintenance_mode = maintenance_mode

    @property
    def stop_jobs_strategy(self):
        """Gets the stop_jobs_strategy of this SessionMaintenanceModeParameters.  # noqa: E501


        :return: The stop_jobs_strategy of this SessionMaintenanceModeParameters.  # noqa: E501
        :rtype: str
        """
        return self._stop_jobs_strategy

    @stop_jobs_strategy.setter
    def stop_jobs_strategy(self, stop_jobs_strategy):
        """Sets the stop_jobs_strategy of this SessionMaintenanceModeParameters.


        :param stop_jobs_strategy: The stop_jobs_strategy of this SessionMaintenanceModeParameters.  # noqa: E501
        :type: str
        """
        allowed_values = ["SoftStop", "Kill"]  # noqa: E501
        if (self._configuration.client_side_validation and
                stop_jobs_strategy not in allowed_values):
            raise ValueError(
                "Invalid value for `stop_jobs_strategy` ({0}), must be one of {1}"  # noqa: E501
                .format(stop_jobs_strategy, allowed_values)
            )

        self._stop_jobs_strategy = stop_jobs_strategy

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(SessionMaintenanceModeParameters, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SessionMaintenanceModeParameters):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, SessionMaintenanceModeParameters):
            return True

        return self.to_dict() != other.to_dict()
